function y = blkdiag(varargin)
%BLKDIAG  Block diagonal concatenation of input arguments.
%
%                                   |A 0 .. 0|
%   Y = BLKDIAG(A,B,...)  produces  |0 B .. 0|
%                                   |0 0 ..  |
%
%   See also DIAG, HORZCAT, VERTCAT
p=0;
m=0;
for k=1:nargin
    x = varargin{k};
    [p2,m2] = size(x);
    p = p + p2;
    m = m + m2;
end
y = zeros(p,m);
c = 1;
r = 1;
for k=1:nargin
    x = varargin{k};
    [p2,m2] = size(x);
    nr = r+p2-1;
    nc = c+m2-1;
    y(r:nr,c:nc) = x;
    c = nc+1;
    r = nr+1;
end

