clear
clf
smt_init

load -mat mcphedran.gd

lambda = 1.45e-6;
k0 = 2*pi/lambda;
sClass = 'f5'; % Fini's classification
%sClass = 'p4'; % McIsaac's classification
positions = distribute(oGd);
positions = cut_pos(oGd, positions, sClass);
sComponent = 'Ez';

Neff = (1.44539); % the fundamental mode
[error, solution] = smt_solve(Neff, oGd, positions, k0);
error
points = 150;
Dx = 1e-5;
Dy = 1e-5;
x = linspace(-Dx, Dx, points);
y = linspace(-Dy, Dy, points);

field = calc_field(solution, positions, oGd, k0, Neff, sComponent, sClass, x, y);
if isnan(field)
    return
end
imagesc(x, y, abs(field))
axis image
colorbar
draw_geom(oGd, 'noaxischange')
colormap pink