function kc = calc_kc(k0, beta, Er, isHankel, varargin)
if isHankel
    isLeaky = varargin{1}; 
    % isLeaky = 1 means divergent in the radial
    % direction. Relevant only if isHankel = 1.
end
global DELTA
k = k0*sqrt(Er);
if k^2 == beta^2
    beta = k-j*DELTA;
end
kc = sqrt(k^2-beta^2);
kc_r = real(kc);
kc_i = imag(kc);
if isreal(beta)
    kc = abs(kc_r)-j*abs(kc_i);
    return
else
    if ~isHankel | (isHankel & ~isLeaky)
        % Absorber instead of sources
        kc_r = -abs(kc_r);
    else
        % Leaky mode sources
        kc = abs(kc_r);
    end
end
delta = 0.5*imag(Er)*k0^2-real(beta)*imag(beta);
kc_i = delta/kc_r;
kc = kc_r + j*kc_i;

