function sdPosOut = cut_sd(sdPos, x0, y0, ang, bAbove, bUpdateN)
% cut-off all testing-points or sources other than the ones in the first 'ang' degree sector
sdPosOut = sdPos;
if isempty(sdPos.vY)
        return
end
delta = mean(abs(diff(sdPos.vY)+ j*diff(sdPos.vX)))/10; % avoid a point on the sector edge
if ~bAbove 
        delta = -delta*tan(ang);
end
vI = find(xor(~bAbove, sdPos.vY-tan(ang)*(sdPos.vX-x0) > y0 + delta));
sdPosOut.vX = sdPos.vX(vI);
sdPosOut.vY = sdPos.vY(vI);
if isfield(sdPos, 'vNx')
        sdPosOut.vNx = sdPos.vNx(vI);
        sdPosOut.vNy = sdPos.vNy(vI);
end
if bUpdateN
        sdPosOut.n = length(sdPosOut.vX);
else
        sdPosOut.n = sdPos.n;
end