function [Fe, Ee, Be, Fm, Em, Bm] = green_fun(testing, sources, Y, kc, beta, oGd)
rows = length(testing.vX);
cols = length(sources.vX);
ang = 2*pi/length(sources.vGreen);
[Fe, Ee, Be, Fm, Em, Bm] = deal(zeros(rows, cols));
bFini = any(imag(sources.vGreen));
for iReflect = 1:length(sources.vGreen)
        [iFe, iEe, iBe] = e_sources(testing, sources, Y, kc, beta);
        iFe = iFe*sources.vGreen(iReflect);
        iEe = iEe*sources.vGreen(iReflect);
        iBe = iBe*sources.vGreen(iReflect);
        iFm = iFe*(2*bFini-1)^(iReflect-1);
        iEm = iEe*(2*bFini-1)^(iReflect-1);
        iBm = iBe*(2*bFini-1)^(iReflect-1);
        Fe = Fe + iFe;
        Ee = Ee + iEe;
        Be = Be + iBe;
        Fm = Fm + iFm;
        Em = Em + iEm;
        Bm = Bm + iBm;
        if iReflect ~= length(sources.vGreen)
                [sources.vX, sources.vY] = reflect(sources.vX, sources.vY, ang, iReflect,...
                        oGd.offsetX, oGd.offsetY);
        end
end