function varargout = smtgui(varargin)
% Source-Model Technique Graphical User Interface
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
        'gui_Singleton',  gui_Singleton, ...
        'gui_OpeningFcn', @smtgui_OpeningFcn, ...
        'gui_OutputFcn',  @smtgui_OutputFcn, ...
        'gui_LayoutFcn',  [] , ...
        'gui_Callback',   []);
if nargin & isstr(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
        gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before smtgui is made visible.
function smtgui_OpeningFcn(hObject, eventdata, handles, varargin)
global EPSILON0 MU0 C DELTA ETA bCancel
global server_names server_con
global FontSize defPointsX defPointsY
C = 2.99792458e8; %[m/sec]
EPSILON0 = 1e7/(4*pi*C^2); %[F/m]
MU0 = 4*pi*1e-7; %[H/m]
ETA = sqrt(MU0/EPSILON0);
DELTA = 1e-5;
FontSize = 15;
bCancel = 0;
defPointsX = 150;
defPointsY = 150;
% load config
% pnet_remote('closeall');
% pnet closeall;
% for ind = 1:length(ports)
%     servername = server_names(ind,:);
%     port = ports(ind);
%     con = pnet_remote('connect', servername, port);
%     if con == -1
%         uiwait(errordlg(['Could not connect to server: ' servername], 'Smtgui', 'modal'));
%         continue
%     end
%     pnet_remote(con, 'eval', 'init');
%     server_con = [server_con con];
% end
toggle_save(handles);
uiNew_Callback(hObject, eventdata, handles)
add_to_text(hObject, handles, '>> smt_init');

% UIWAIT makes smtgui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = smtgui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in uiFindModes.
function uiFindModes_Callback(hObject, eventdata, handles)
global server_names server_con
global sResults sFirstResults FontSize
% hObject    handle to uiFindModes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~check_oGd(handles)
        return
end
data = gui_findbeta('min_lambda', num2str(handles.min_lambda), 'max_lambda', num2str(handles.max_lambda),...
        'n_lambda', num2str(handles.n_lambda),'min_beta', num2str(handles.min_beta),...
        'max_beta', num2str(handles.max_beta), 'tol', num2str(handles.tol), ...
        'sm', num2str(handles.sm), 'bPlot', num2str(handles.bPlot), 'nStart', num2str(handles.nStart));
if data.status == 0
        if isSaveOff(handles)
                toggle_save(handles)
        end
        handles.nStart = data.nStart_val;
        handles.max_beta = data.max_beta_val;
        handles.min_beta = data.min_beta_val;
        handles.min_lambda = data.min_lambda_val;
        handles.max_lambda = data.max_lambda_val;
        handles.n_lambda = data.nLambda_val;
        handles.bPlot = data.bPlot;
        handles.tol = data.tol;
        handles.sm = data.sm;
        if handles.n_lambda == 1
                vLambda = handles.min_lambda;
        else
                vLambda = linspace(handles.min_lambda, handles.max_lambda, handles.n_lambda);
        end
        guidata(hObject, handles);
        if ~isfield(handles, 'pos')
                make_geom(hObject, handles);
                handles = guidata(hObject);
        end
        oGd = handles.oGd;
        pos = handles.pos;
        if handles.strClass(1) ~= 'n'
                pos = cut_pos(oGd, pos, handles.strClass);
        end
        tol = data.tol;
        sm = data.sm;
        nStart = data.nStart_val;
        bPlot = data.bPlot;
        bDisp = (length(vLambda)>1);
        if bPlot & bDisp
                bPlot = 2;
        end
        mBeta = [];
        mErr = [];
        for iLambda = 1:length(vLambda)
                lambda = vLambda(iLambda);
                k0 = 2*pi/lambda;
                s1 = '>> [Neff, Err] = find_modes(oGd, positions, 2*pi/lambda, min_Neff, max_Neff, tol, smooth, bShow, nStart);';
                s2 = sprintf('   %% lambda = %g, min_Neff = %g, max_Neff = %g, tol = %g, smooth = %g, bShow = %1.0f, nStart = %d',...
                        lambda, handles.min_beta, handles.max_beta, tol, sm, bPlot, nStart);
                add_to_text(hObject, handles, s1, s2);
                tic
                figure(handles.figure1);
                if isempty(server_names)
                        [vBeta, vErr] = find_modes(oGd, pos, k0, handles.min_beta, handles.max_beta, tol, sm, bPlot, nStart);
                else
                        [vBeta, vErr] = find_modes_p(pos, k0, handles.min_beta, handles.max_beta, tol, sm, bPlot);
                end
                toc
                if vBeta == -1
                        figure(handles.figure1);
                        hAx = subplot(20,2,3:30);
                        cla(hAx)
                        guidata(hObject, handles);
                        draw_geom(oGd);
                        return
                end
                if bDisp & (iLambda == 1)
                        sResults = sFirstResults;
                end
                if isempty(vBeta) & ~bDisp
                        uiwait(msgbox('No modes found. Try increasing smoothness criterion or initial No. of samples.', 'smtgui', 'warn', 'modal'));
                        guidata(hObject, handles);
                        draw_geom(oGd);
                        return
                end
                vBeta = vBeta(:);
                vErr = vErr(:);
                if isempty(mBeta)
                        mBeta = [mBeta vBeta];
                        mErr = [mErr vErr];
                else
                        PrevBeta = mBeta(:,end);
                        PrevNaN = ones(length(vBeta)-length(PrevBeta), size(mBeta,2))*NaN;
                        CurrNaN = ones(length(PrevBeta)-length(vBeta), 1)*NaN;
                        if ~isempty(PrevNaN)
                                mBeta = [mBeta; PrevNaN];
                        end
                        if ~isempty(CurrNaN)
                                vBeta = [vBeta; CurrNaN];
                        end
                        mBeta = [mBeta vBeta];
                end
                if isempty(mBeta)
                        continue
                end
                if bDisp
                        figure(handles.figure1);
                        hAx = subplot(20,2,(3:2:30)+1);
                        cla(hAx)
                        plot(2*pi./vLambda(1:iLambda), mBeta, 'b.')
                        fixfonts(hAx, FontSize)
                        xlabel(hAx, 'k_0 [1/m]')
                        ylabel(hAx, 'n_{eff}')
                        drawnow
                end
                f = findobj('name', 'Set Parameters');
                close(f)
                data = show_results('dummy', 'dummy', 'Toggle', handles.uiShowRes, 'Beta', num2str(vBeta,'%0.20g'), 'Err', num2str(vErr), 'Tol', num2str(tol),...
                        'lambda', num2str(lambda,'%0.6g'));
        end
        if isempty(mBeta)
                uiwait(msgbox('No modes found. Try increasing smoothness criterion or initial No. of samples.', 'smtgui', 'warn', 'modal'));
                guidata(hObject, handles);
                figure(handles.figure1)
                hAx = subplot(20,2,3:30);
                draw_geom(oGd);
                return
        end
        if bDisp
                hFig = figure;
                set(hFig, 'name', 'Dispersion Curves')
                if ispc
                        set(hFig, 'color', [236 233 216]/256);
                end
                plot(2*pi./vLambda(1:iLambda), mBeta, 'b.')
                fixfonts(gca, FontSize)
                xlabel(gca, 'k_0 [1/m]')
                ylabel(gca, 'n_{eff}')
        end
        figure(handles.figure1)
        hAx = subplot(20,2,3:30);
        draw_geom(oGd);
        handles.axes = hAx;
        handles.hResults = data.figure1;
        set(handles.uiShowRes, 'Value', 1);
        if bDisp
                figure(hFig);
        else
                figure(data.figure1)
        end
        guidata(hObject, handles);
end

% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function load_geom_Callback(hObject, eventdata, handles)
global sResults
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = -1;
while 1
        [file, pathname, filter] = uigetfile( {'*.gd','Geometry Description Files (*.gd)';
                '*.se', 'Session File (*.se)'}, 'Open Session/Geometry', '');
        if isequal(file, 0)
                break;
        end
        if strcmp(file(end-2:end), '.se') % session file
                s = load('-mat', [pathname file], 'oSettings', 'sResults');
                sResults = s.sResults;
                if ~isfield(s, 'oSettings')
                        h = errordlg('Settings file does not include an ''oSettings'' variable', 'Error');
                        set(h, 'windowstyle', 'modal');
                        waitfor(h);
                        continue
                else
                        oSettings = s.oSettings;
                        handles.sesPath = pathname;
                        handles.sesFile = file;
                        fields = fieldnames(oSettings);
                        for ind = 1:length(fields)
                                field = fields{ind};
                                handles = setfield(handles, field, getfield(oSettings, field));
                        end
                end
                pathname = handles.gdPath;
                file = handles.gdFile;
                if ispc
                        file_separator = '\';
                else
                        file_separator = '/';
                end
                if isempty(dir([pathname file]))
                        if isempty(dir([pwd file_separator file]))
                                h = errordlg(['Geometry description file ' pathname file ' not found'], 'Error');
                                set(h, 'windowstyle', 'modal');
                                waitfor(h);
                                return
                        end
                        pathname = [pwd file_separator];
                        handles.gdPath = pathname;
                end
                f = findobj('name', 'Effective Indices');
                close(f);
        end
        s = load('-mat', [pathname file], 'oGd');
        if isSaveOff(handles)
                toggle_save(handles)
        end
        if ~isfield(s, 'oGd')
                h = errordlg('Geometry file does not include an ''oGd'' variable', 'Error');
                set(h, 'windowstyle', 'modal');
                waitfor(h);
                continue
        else
                if isfield(handles, 'pos')
                        handles  = rmfield(handles, 'pos');
                end
                set(handles.text, 'String', strvcat('Command-line log', ['>> load -mat ' file], ['>> draw_geom(oGd)']))
                oGd = s.oGd;
                handles.gdFile = file;
                handles.gdPath = pathname;
                set(handles.figure1, 'name', ['Smtgui - ' handles.sesFile ' (Geometry: ' file ')']);
                f = findobj('name', 'Set Parameters');
                close(f)
                f = findobj('name', 'Mode Plot');
                close(f)
                figure(handles.figure1)
                handles.axes = subplot(20,2,3:30);
                axes(handles.axes);
                cla
                draw_geom(oGd);
                handles.oGd = oGd;
                if get(handles.uiShowHide, 'Value')
                        make_geom(hObject, handles);
                        handles = guidata(hObject);
                        pos = handles.pos;
                        show_pos(oGd, pos);
                end

                ax = handles.axes;
                xlim = get(ax, 'xlim');
                ylim = get(ax, 'ylim');
                handles.xmin = xlim(1);
                handles.xmax = xlim(end);
                handles.ymin = ylim(1);
                handles.ymax = ylim(end);
                guidata(hObject, handles);
                break
        end
end

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
bOk = check_before_close(handles);
if bOk
        f = findobj('name', 'Effective Indices');
        delete(f)
        f = findobj('name', 'Set Parameters');
        close(f)
        f = findobj('name', 'Mode Plot');
        delete(f)
        delete(handles.figure1)
end


% --- Executes during object creation, after setting all properties.
function text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
        set(hObject,'BackgroundColor','white');
else
        set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function text_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of text as text
%        str2double(get(hObject,'String')) returns contents of text as a
%        double

% --- Executes during object creation, after setting all properties.
function axes_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes


% --------------------------------------------------------------------
function uiSave_res_Callback(hObject, eventdata, handles)
% hObject    handle to uiSave_res (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function uiSave_log_Callback(hObject, eventdata, handles)
% hObject    handle to uiSave_log (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in uiPlotFields.
function uiPlotFields_Callback(hObject, eventdata, handles)
global sResults
% hObject    handle to uiPlotFields (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
f = findobj('name', 'Set Parameters');
if ~isempty(f)
        figure(f)
        return
end
if ~check_oGd(handles)
        return
end
if ~isfield(handles, 'pos')
        make_geom(hObject, handles);
        handles = guidata(hObject);
end
pos = handles.pos;
add_to_text(hObject, handles, '>> % Solution is calculated at a specific point on the dispersion curve by:',...
        '>> [L, vSolution] = smt_solve(Neff, oGd, positions, 2*pi/lambda);',...
        '>> % L is the error, vSolution the source amplitudes, Neff - effective index, lambda - wavelength',...
        '>> % Field is calculated by:',...
        '>> mF = CalcField(vSolution, positions, oGd, 2*pi/lambda, Neff*2*pi/lambda, strComp, strClass, vX, vY);',...
        '>> % strComp is the field component: ''Ez'', etc.',...
        '>> % strClass is the symmetry class: ''p5'', ''f3'', etc.',...
        '>> % vectors vX and vY: X and Y values for evaluation');
data = gui_field_plot('xmin', num2str(handles.xmin), 'xmax', num2str(handles.xmax),...
        'ymin', num2str(handles.ymin), 'ymax', num2str(handles.ymax),...
        'scomp', handles.sComp, 'pointsx', num2str(handles.pointsx), 'pointsy', num2str(handles.pointsy),...
        'recent', sResults, 'pos', handles.pos, 'oGd', handles.oGd, 'class', handles.strClass);



% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in uiOpen.
function uiOpen_Callback(hObject, eventdata, handles)
% hObject    handle to uiOpen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in uiShowHide.
function uiShowHide_Callback(hObject, eventdata, handles)
% hObject    handle to uiShowHide (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of uiShowHide
if ~check_oGd(handles)
        set(hObject, 'Value', 0)
        return
end
if ~get(hObject, 'Value')
        draw_geom(handles.oGd);
        add_to_text(hObject, handles, '>> draw_geom(oGd)')
        return
end
if ~isfield(handles, 'pos')
        h = msgbox('Calculating location of sources and testing points...', 'SMTgui', 'help');
        make_geom(hObject, handles);
        handles = guidata(hObject);
        close(h);
end
pos = handles.pos;
add_to_text(hObject, handles, '>> show_pos(oGd, positions)')
show_pos(handles.oGd, pos);

% --- Executes on button press in uiDisp.
function uiDisp_Callback(hObject, eventdata, handles)
% hObject    handle to uiDisp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function make_geom(hObject, handles)
s = get(handles.text, 'string');
set(handles.text, 'string', strvcat(s, '>> positions = distribute(oGd);   % Distribute sources and testing points'));
handles.pos = distribute(handles.oGd);
guidata(hObject, handles);

function add_to_text(hObject, handles, varargin)
for ind = 1:nargin-2
        set(handles.text, 'string', strvcat(get(handles.text, 'string'), varargin{ind}))
end
height = 6;
s =  size(get(handles.text, 'string'),1);
if s > height
        set(handles.text, 'ListBoxTop', s-height);
end
pause(0.1)

function bOk = check_oGd(handles)
if ~isfield(handles, 'oGd')
        h = errordlg('Please load a geometry first.', 'Error');
        set(h, 'windowstyle', 'modal');
        waitfor(h);
        bOk = 0;
else
        bOk = 1;
end


% --- Executes on button press in uiSrc.
function uiSrc_Callback(hObject, eventdata, handles)
% hObject    handle to uiSrc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~check_oGd(handles)
        return
end
if isfield(handles, 'pos')
        data = gui_set_parameters('oGd', handles.oGd, 'pos', handles.pos);
else
        data = gui_set_parameters('oGd', handles.oGd);
end
if data.status == -1
        return
end
add_to_text(hObject, handles, ['>> oGd.nSources = ' num2str(data.oGd.nSources) ';'],...
        ['>> oGd.nTestingPoints = ' num2str(data.oGd.nTestingPoints) ';'],...
        ['>> oGd.alphaIn = ' num2str(data.oGd.alphaIn) '; % inner sources distance'],...
        ['>> oGd.alphaOut = ' num2str(data.oGd.alphaOut) '; % outer sources distance'])
handles.oGd = data.oGd;
handles.pos = data.pos;
oGd = data.oGd;
save([handles.gdPath handles.gdFile], 'oGd');
if get(handles.uiShowHide, 'Value') == 1
        show_pos(oGd, data.pos);
end
guidata(hObject, handles);


% --- Executes on button press in uiSave.
function uiSave_Callback(hObject, eventdata, handles)
global sResults
% hObject    handle to uiSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmp(handles.sesFile, 'untitled.se')
        uiSaveAs_Callback(hObject, eventdata, handles);
        if strcmp(handles.sesFile, 'untitled.se')
                return
        end
end
oSettings = handles;
fields = fieldnames(oSettings);
for ind = 1:length(fields)
        field = fields{ind};
        handle = eval(['handles.' field]);
        if all(ishandle(handle)) & handle ~= 0
                oSettings = rmfield(oSettings, field);
        end
end
save([handles.sesPath handles.sesFile], 'oSettings', 'sResults');
toggle_save(handles);

% --- Executes on button press in uiNew.
function uiNew_Callback(hObject, eventdata, handles)
global server_names server_con
global defPointsX defPointsY
global sResults sFirstResults
% hObject    handle to uiNew (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

bOk = check_before_close(handles);
if bOk
        if ~isSaveOff(handles)
                toggle_save(handles);
        end
else
        return
end
server_names = [];
server_con = [];
handles.output = hObject;
handles.min_lambda = 0;
handles.max_lambda = 0;
handles.n_lambda = 1;
handles.min_beta = 0;
handles.max_beta = 0;
handles.bPlot = 1;
handles.tol = 1e-6;
handles.sm = 1;
handles.nStart = 5;
sFirstResults = 'Mode #    Eff. Index            CC Error';
sResults = sFirstResults;
handles.pointsx = defPointsX;
handles.pointsy = defPointsY;
handles.strClass = 'none';
if isfield(handles, 'oGd')
        handles = rmfield(handles, 'oGd');
end
if isfield(handles, 'pos')
        handles = rmfield(handles, 'pos');
end
set(handles.text, 'String', 'Command-line log');
set(handles.figure1, 'name', ['Smtgui - untitled.se (Geometry: None)']);
handles.pointsx = defPointsX;
handles.pointsy = defPointsY;
handles.sComp = 'Ez';
handles.gdFile = 'None';
handles.gdPath = '';
handles.sesFile = 'untitled.se';
if isfield(handles, 'axes')
        delete(handles.axes)
        handles = rmfield(handles, 'axes');
end
f = findobj('name', 'Effective Indices');
close(f);
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
        set(hObject,'BackgroundColor','white');
else
        set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2


% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton15.
function pushbutton15_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2


% --- Executes on button press in uiServer.
function uiServer_Callback(hObject, eventdata, handles)
global server_names server_con
% hObject    handle to uiServer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answer = inputdlg({'Enter name of server:', 'Enter port number'}, 'Smtgui', 1, {'', '5678'});
servername = answer{1};
port = str2num(answer{2});
if isempty(servername)
        return
end

con = pnet_remote('connect', servername, port);
if con == -1
        errordlg(['Could not connect to server: ' servername], 'Smtgui');
        return
else
        waitfor(msgbox(['Connection to server: ' servername ' established successfully'], 'Smtgui'))
end
pnet_remote(con, 'EVAL', 'init');
server_con = [server_con con];
server_names = strvcat(server_names, servername);


% --- Executes on button press in uiSymmetry.
function uiSymmetry_Callback(hObject, eventdata, handles)
% hObject    handle to uiSymmetry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = gui_Symmetry(handles.strClass);
if strcmp(handles.strClass, data.strClass)
        return
end
if isSaveOff(handles)
        toggle_save(handles)
end
add_to_text(hObject, handles, ['>> positions = cut_pos(oGd, positions, ''' data.strClass ''');']);
f = findobj('tag', 'uiSym');
if ~isempty(f)
        set(f, 'string', ['Class: ' data.strClass])
end
handles.strClass = data.strClass;
guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of uiSymmetry


% --------------------------------------------------------------------
function new_session_Callback(hObject, eventdata, handles)
% hObject    handle to new_session (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiNew_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function uiSaveAs_Callback(hObject, eventdata, handles)
% hObject    handle to uiSaveAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname, filter] = uiputfile( {'*.se','Session File (*.se)'},...
        'Save Session as:', 'untitled.se');
if filter < 1
        return
end
handles.sesFile = filename;
handles.sesPath = pathname;
set(handles.figure1, 'name', ['Smtgui - ' filename ' (Geometry: ' handles.gdFile ')']);
guidata(hObject, handles);
uiSave_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function save_session_Callback(hObject, eventdata, handles)
% hObject    handle to save_session (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiSave_Callback(hObject, eventdata, handles)



% --- Executes on button press in uiShowRes.
function uiShowRes_Callback(hObject, eventdata, handles)
% hObject    handle to uiShowRes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject, 'Value')
        data = show_results('dummy', 'dummy', 'Toggle', hObject );
        handles.hResults = data.figure1;
        guidata(hObject, handles);
else
        delete(handles.hResults);
end




% --- Executes on button press in uiNewGeom.
function uiNewGeom_Callback(hObject, eventdata, handles)
% hObject    handle to uiNewGeom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = gui_MakeCurves;
if ~isfield(data, 'oGd')
        return
end
add_to_text(hObject, handles, '>> % Spline curves stored in oGd.curveArray')
file_suggest = data.filename;
data = gui_SetEpsilon('oGd', data.oGd);
if data.status == -1
        return
end
add_to_text(hObject, handles, '>> % Sub-domains stored in oGd.sdArray',...
        '>> % permittivities stored in oGd.sdArray.Er',...
        '>> % first sub-domain is always the background material')
data = gui_set_parameters('oGd', data.oGd);
if data.status == -1
        return
end
add_to_text(hObject, handles, ['>> oGd.nSources = ' num2str(data.oGd.nSources) ';'],...
        ['>> oGd.nTestingPoints = ' num2str(data.oGd.nTestingPoints) ';'],...
        ['>> oGd.alphaIn = ' num2str(data.oGd.alphaIn) '; % inner sources distance'],...
        ['>> oGd.alphaOut = ' num2str(data.oGd.alphaOut) '; % outer sources distance'])
[filename, pathname, filter] = uiputfile({'*.gd', 'Geometry Description Files (*.gd)'},...
        'Save As...', [file_suggest(1:end-2) '.gd']);
if filter < 1
        return
end
oGd = data.oGd;
save([pathname filename], 'oGd');



% --- Executes on button press in uiEpsilon.
function uiEpsilon_Callback(hObject, eventdata, handles)
% hObject    handle to uiEpsilon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of uiEpsilon
if ~check_oGd(handles)
        return
end
data = gui_SetEpsilon('oGd', handles.oGd);
if data.status == -1
        return
end
add_to_text(hObject, handles, '>> % Sub-domains stored in oGd.sdArray',...
        '>> % permittivities stored in oGd.sdArray.Er',...
        '>> % first sub-domain is always the background material')
handles.oGd = data.oGd;
oGd = handles.oGd;
save([handles.gdPath handles.gdFile], 'oGd')
guidata(hObject, handles);



% --------------------------------------------------------------------
function uiMenuNewGeom_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuNewGeom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiNewGeom_Callback(handles.uiNewGeom, eventdata, handles)



% --------------------------------------------------------------------
function Untitled_2_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function uiSet_Callback(hObject, eventdata, handles)
% hObject    handle to uiSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function uiMenuEpsilon_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuEpsilon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiEpsilon_Callback(handles.uiEpsilon, eventdata, handles)

% --------------------------------------------------------------------
function uiMenuSrc_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuSrc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiSrc_Callback(handles.uiSrc, eventdata, handles)



% --------------------------------------------------------------------
function uiMenuSym_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuSym (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiSymmetry_Callback(handles.uiSymmetry, eventdata, handles)



% --------------------------------------------------------------------
function uiMenuFind_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuFind (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiFindModes_Callback(handles.uiFindModes, eventdata, handles)

% --------------------------------------------------------------------
function uiSolve_Callback(hObject, eventdata, handles)
% hObject    handle to uiSolve (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function uiMenuPlot_Callback(hObject, eventdata, handles)
% hObject    handle to uiMenuPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiPlotFields_Callback(handles.uiPlotFields, eventdata, handles)

function toggle_save(handles)
state = get(handles.uiSave, 'Enable');
if ~isSaveOff(handles)
        set(handles.uiSave, 'enable', 'off')
        set(handles.save_session, 'enable', 'off')
else
        set(handles.uiSave, 'enable', 'on')
        set(handles.save_session, 'enable', 'on')
end

function out = isSaveOff(handles)
out = strcmp(lower(get(handles.uiSave, 'Enable')), 'off');

function bOk = check_before_close(handles)
if ~isSaveOff(handles)
        selection = questdlg([handles.sesFile ' session is not saved. Close without saving?'],...
                ['Close Session...'],...
                'Yes','No','Yes');
        if strcmp(selection,'No')
                bOk = 0;
                return;
        end
end
bOk = 1;


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
CloseMenuItem_Callback(hObject, eventdata, handles)




% --------------------------------------------------------------------
function uiSaveLog_Callback(hObject, eventdata, handles)
% hObject    handle to uiSaveLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

s = get(handles.text, 'string');
[FileName, PathName, FilterIndex] = uiputfile('Text File (*.txt)', 'Save as', 'smt_log.txt');
if FilterIndex < 1
        return
end
fn = [PathName FileName];
fid = fopen(fn, 'w');
for ind = 1:size(s, 1)
        fprintf(fid, s(ind,:));
        fprintf(fid, '\n');
end
fclose(fid);
% --------------------------------------------------------------------
function uiClearLog_Callback(hObject, eventdata, handles)
% hObject    handle to uiClearLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.text, 'string', 'Command-line log')

% --------------------------------------------------------------------
function uiLog_Callback(hObject, eventdata, handles)
% hObject    handle to uiLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


